package sklep.security;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.provisioning.InMemoryUserDetailsManager;
import org.springframework.security.web.SecurityFilterChain;

@Configuration
@EnableWebSecurity
public class SecurityConfig {
	@Bean
	SecurityFilterChain setHttpSecurity(HttpSecurity httpSecurity) throws Exception {
		httpSecurity
			.authorizeHttpRequests((authz) -> authz
					.anyRequest().authenticated()
				)
			.formLogin();
		return httpSecurity.build();
	}
	
//	@Bean
//	AuthenticationManager authenticationManager(AuthenticationConfiguration authenticationConfiguration, ApplicationContext applicationContext) throws Exception {
//        ObjectPostProcessor<Object> objectPostProcessor = new ObjectPostProcessor<Object>() {
//			public <O> O postProcess(O object) {
//				return object;
//			}
//		};
//		
//		return authenticationConfiguration.authenticationManagerBuilder(objectPostProcessor, applicationContext)
//				.inMemoryAuthentication()
//				.withUser("ala").password("{noop}ala123").roles("manager", "worker").and()
//				.withUser("ola").password("{noop}ola123").roles("worker").and()
//			.and()
//			.build();
//	}
	
	@Bean
	public InMemoryUserDetailsManager userDetailsService() {
		UserDetails[] users = {
				User.withUsername("ala").password("{noop}ala123").roles("manager", "worker").build(),
				User.withUsername("ola").password("{noop}ola123").roles("worker").build(),
		};
		return new InMemoryUserDetailsManager(users);
	}
}
